Index: tdomf.php
===================================================================
--- tdomf.php	(revision 169181)
+++ tdomf.php	(working copy)
@@ -1,390 +1,390 @@
-<?php
-/*
-Plugin Name: TDO Mini Forms
-Plugin URI: http://thedeadone.net/download/tdo-mini-forms-wordpress-plugin/
-Description: This plugin allows you to add custom posting forms to your website that allows your readers (including non-registered) to submit posts.
-Version: 0.13.5
-Author: Mark Cunningham
-Author URI: http://thedeadone.net
-*/
-
-/*  Copyright 2006-2007  Mark Cunningham  (email : tdomf@thedeadone.net)
-
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 2 of the License, or
-    (at your option) any later version.
-
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-
-    You should have received a copy of the GNU General Public License
-    along with this program; if not, write to the Free Software
-    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-*/
-
-////////////////////////////////////////////////////////////////////////////////
-// Version History
-//
-// See readme.txt
-//
-// v0.13.5
-// - Previous recent versions prevented people from enabling spam. The code was
-//     written in such a way that the spam protection had to be enabled before
-//     spam protection could be enabled!
-// - Replaced the usage of $_REQUEST with $_POST in form hacker. Not sure if
-//     it'll have any impact on the form-hacker-reset problem but it should
-//     be safer
-// - Have tested and fixed extra slashes being added on WP 2.8.x builds with and
-//     without magic quotes turned on. 
-// - Refactored Custom Field, Content, Excerpt widgets and created a common
-//     textfield and textarea (as part of the fix for magic quotes). This allows
-//     me to add new features to multiple widgets at a time. 
-//
-////////////////////////////////////////////////////////////////////////////////
-
-/*
-////////////////////////////////////////////////////////////////////////////////
-Work Queue:
-
-Bugs
-====
-   - 'gmt_offset' not calcualted in %%SUBMISSIONDATE%%
-   - not working with vbbridge - http://thedeadone.net/forum/?p=2805#comment-4296
-   - image capatcha must update after failed "submit"
-   - Possible incompatibility with Google XML Sitemaps plugin - http://thedeadone.net/forum/?p=1923
-   - Bug in GeoMashup - http://thedeadone.net/forum/?p=2062#comment-4070
-   - Bug TwitterTools not working with TDOMF publish - http://thedeadone.net/forum/?p=1916#comment-3972
-   - Sanatized file upload filenames/paths - http://thedeadone.net/blog/v0127-of-tdo-mini-forms-just-released/comment-page-1/#comment-181601
-   - diacritc marks reset form hacker: http://thedeadone.net/forum/?p=1888#topic-1888
-   - Bug: Illegal characters in file names: http://thedeadone.net/forum/?p=1544#topic-1544
-   - Bug: Weird "From" email for post moderation emails: http://thedeadone.net/forum/?p=71
-   - Bug: No image preview when using attachment options: http://thedeadone.net/forum/?p=1498#comment-3485
-   - Bug: slashes: http://thedeadone.net/forum/?p=1444#comment-3331 (but it might be related to AJAX!)
-   - Bug: Widget configuration panels not showing up: http://thedeadone.net/forum/?p=1379
-   - Investigate: no sidebars in widget configuration in IE.7
-   - Investigate: tinymce conflict with AJAX form
-   - Investigate: upload-link error:
-       http://wordpress.org/support/topic/186919#post-838957
-
-TODO
-====
-   - Allow options to format the "submitted by" text and also disabling for registered users
-   - Quicktag like options for form hacker
-   - Investigate: Copy widgets to other forms
-   - Allow Error, StyleSheet and Validation Form Hacking
-   - Allow only the Form or the Preview to be "hacked" in the Form Hacker
-   - Add Error Warning for custom field widgets when non-unique keys used
-   - Investigate: Auto bring up the conf panel for widgets on the "fix" links
-
-Feature Requests
-================
-   - delete spam straight away (TDOMF_OPTION_SPAM_AUTO_DELETE_NOW already setup, just not implemented)
-   - parent category - http://thedeadone.net/forum/?p=3205#comment-4524
-   - display less information and perhaps some sort of funky JS to order columns - http://thedeadone.net/forum/?p=3526#comment-4514
-   - category names instead of ids - http://thedeadone.net/forum/?p=3171#topic-3171
-   - widget class have functions to allow message customisation
-   - "delete all spam"
-   - "recheck for spam"
-   - Most pages private... - http://thedeadone.net/forum/?p=224#comment-4221
-   - Requred option in category field
-   - Related posts! http://thedeadone.net/forum/?p=1904#comment-3937
-   - Entry in FAQ: Widget Changes not showing up
-   - Investigate: Integeration with NextGen
-   - Template: List of submitters
-   - Code: Tags as checkboxes - http://thedeadone.net/forum/?p=1377
-   - Some simple javascript to track number of chars/words typed so far in textarea: http://thedeadone.net/forum/?p=1321
-   - Study: http://wordpress.org/extend/plugins/download-monitor/ integration
-
-Other
-=====
-   - Code to add a email hook on publish - http://thedeadone.net/forum/?p=3195#comment-4519
-   - http://thedeadone.net/forum/?p=2100#comment-4278 (alternative input?)   
-
-
-*/
-
-/*
-Magic Quotes for 0.13.5:
-
-Wordpress 2.8.2
-+++++++++++++++
-
-Magic Quotes: ON
-================
-Widget Screen    : OK
-Form Hacker      : OK
-
-[AJAX: On]         Title | Content | Excerpt | CF: TextArea | CF: TextField
---------------------------------------------------------------------------          
-New-Post-Preview : OK    | OK      | OK      | OK           | OK
-New-Post-Submit  : OK    | OK      | OK      | OK           | OK
-Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
-Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
-
-[AJAX: Off]        Title | Content | Excerpt | CF: TextArea | CF: TextField
---------------------------------------------------------------------------
-New-Post-Preview : OK    | OK      | OK      | OK           | OK
-New-Post-Submit  : OK    | OK      | OK      | OK           | OK
-Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
-Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
-
-Magic Quotes: OFF
-=================
-Widget Screen    : OK
-Form Hacker      : OK
-
-[AJAX: On]         Title | Content | Excerpt | CF: TextArea | CF: TextField
---------------------------------------------------------------------------          
-New-Post-Preview : OK    | OK      | OK      | OK           | OK
-New-Post-Submit  : OK    | OK      | OK      | OK           | OK
-Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
-Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
-
-[AJAX: Off]        Title | Content | Excerpt | CF: TextArea | CF: TextField
---------------------------------------------------------------------------
-New-Post-Preview : OK    | OK      | OK      | OK           | OK
-New-Post-Submit  : OK    | OK      | OK      | OK           | OK
-Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
-Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
-
-*/
-
-/*
-////////////////////////////////////////////////////////////////////////////////
-Notes:
- - Potential nice hack: query.php @ line 1479
-   $this->posts = apply_filters('the_posts', $this->posts);
-     1. is single/page [should include category and index?]
-     2. what post?
-     3. is it tdomf, draft/unmoderation, not spam, viewer is submitter
-     4. add to array
-     This will allow users see their submitted posts, however comments should
-     be disabled as they cannot be used in preview mode
- - What Clickable links in your posts? http://thedeadone.net/forum/?p=500#comment-1598
-*/
-
- /*
-////////////////////////////////////////////////////////////////////////////////
-TODO for future versions
-
-Known Bugs
-- Upload Link error
-- TinyMCE integration problem with AJAX
-
-New Features
-- Option to redirect all comment notifications on submitted posts to the admin (globally or per form)
-- Allow moderators append a message to the approved/rejected notification (allows communication between submitter and moderator)
-- Widget Manager Menu
-  * Info about loaded widgets
-  * Disable loading of specific widgets
-- Style Sheet Editor
-  * Preview
-  * Select from pre-configured Styles
-  * Submit new style to include in TDOMF
-- Email verification of non-registered users
-- Manage Downloads page
-- Authors of posts should be able to see "previews" of post
-- Get input during validation of form (for capatchas)
-- Option to use "Post ready for review" instead of draft for unapproved submitted posts
-- Turn Forms into multiple steps
-- Shortcode Support
-
-New Form Options
-- Force Preview before submission
-- Hide Form on Preview
-- Forms can be used to submit links, emails, etc.
-- Select Form Style/include Custom CSS
-
-New Widgets
-- Widget to allow user to enter a date to post the submission (as in future post)
-- Widget to allow submitter to copy the submission to another email
-- Widget that inputs only title
-  * or that allows formatting of title by
-  * user-input
-  * custom field
-  * username/submitter
-  * date submitted (requires date/time format)
-  * PHP code
-- Login/Register/Who Am I Widget
-
-Existing Widget Improvements
-- Any widget with a size or length field should be customisable.
-- Textfield Class (support numeric, date, email, webpage, etc.)
-- Textarea Class
-- Copy Widget to another Form
-- Individual save
-- Upload Files
-  * Multiple Instances
-  * Thumbnail size
-  * Limit size of image by w/h
-  * Image cropping
-  * Title field for file links/attachment pages
-  * Nicer integration: background uploading using iframe
-  * Prevent submission until files uploaded
-  * Progress bar
-- Content
-  * TinyMCE Integration
-  * Allow users to define their own quicktags
-  * Mechanism to allow sumitter to select where the link/image for upload should go
-  * Default Value
-- Custom Field: Textarea
-  * TinyMCE Integration
-  * Allow users to define their own quicktags
-  * Mechanism to allow sumitter to select where the link/image for upload should go
-  * Default Value
-- Custom Field
-  * Radio Groups
-  * Multiple Checkboxes (grid-layout)
-- Custom Field: Textfield
-  * Numeric
-  * Date
-- Custom Field: Select
-  * Required support
-- Tags
-  * Select from existing tag list or tag cloud
-  * Select from only a specified set of tags
-- 1 Question Captcha
-  * Random questions for Captcha
-- Category
-  * Co-operate with "Set Category from GET variables" Widget
-- Notify Me
-  * Option to always notify submitter
-- Image Captcha
-  * Do not reload image on every preview (would be resolved by a seperate validation step)
-- Text
-  * Option to not use the form formatting (i.e. no "<fieldset>" tags before and after)
-  * Option to have the text popup (would require a HTML space for the link)
-- Set Category from GET variables
-  * Add options (or at least information) for this widget
-  * Co-operate with "Categories" Widget
-- Who Am I
-  * Integration with WP-OpenID?
-  * Allow login as part of form submit
-- Categories
-  * Categories displayed but unselectable
-
-Template Tags
-- Log
-- Moderation Queue
-- Approved Posts
-- File Info
-- Country codes on submitter's IP
-- Image Tags
-
-Misc
-- Documentation on creating your own widgets
-
-////////////////////////////////////////////////////////////////////////////////
-*/
-
-///////////////////////////////////////////////////
-// Defines and other global vars for this Plugin //
-///////////////////////////////////////////////////
-
-// Older versions of PHP may not define DIRECTORY_SEPARATOR so define it here,
-// just in case.
-if(!defined('DIRECTORY_SEPARATOR')) {
-  define('DIRECTORY_SEPARATOR','/');
-}
-
-// Build Number (must be a integer)
-define("TDOMF_BUILD", "51");
-// Version Number (can be text)
-define("TDOMF_VERSION", "0.13.4");
-
-///////////////////////////////////////
-// 0.1 to 0.5 Settings (no longer used)
-//
-define("TDOMF_ACCESS_LEVEL", "tdomf_access_level");
-define("TDOMF_NOTIFY_LEVEL", "tdomf_notify_level");
-
-///////////////////////////////////////
-// 0.6 Settings (no longer used)
-//
-define('TDOMF_NOTIFY','tdomf_notify');
-define("TDOMF_ITEMS_PER_PAGE", 30);
-define("TDOMF_POSTS_INDEX",    0);
-define("TDOMF_USERS_INDEX",    1);
-define("TDOMF_IPS_INDEX",      2);
-define("TDOMF_OPTIONS_INDEX",  3);
-
-/////////////////
-// 0.6 Settings
-//
-define("TDOMF_ACCESS_ROLES", "tdomf_access_roles");
-define("TDOMF_NOTIFY_ROLES", "tdomf_notify_roles");
-define("TDOMF_DEFAULT_CATEGORY", "tdomf_default_category");
-define("TDOMF_DEFAULT_AUTHOR", "tdomf_default_author");
-define("TDOMF_AUTO_FIX_AUTHOR", "tdomf_auto_fix_author");
-define("TDOMF_BANNED_IPS", "tdomf_banned_ips");
-//
-// These keys are used to store info about a post, on the post.
-// Keys with underscore prefix (i.e. "_") are hidden from the general user. Keys
-// without can be modified and displayed using Wordpress normal features such as
-// template tags and custom fields editor.
-//
-define("TDOMF_KEY_FLAG","_tdomf_flag");
-define("TDOMF_KEY_NAME","Author Name");
-define("TDOMF_KEY_EMAIL","Author Email");
-define("TDOMF_KEY_WEB","Author Webpage");
-define("TDOMF_KEY_IP","_tdomf_original_poster_ip");
-define("TDOMF_KEY_USER_ID","_tdomf_original_poster_id");
-define("TDOMF_KEY_USER_NAME","Original Submitter Username");
-//
-// This key is very important. It determines if a user is trusted or banned..
-//
-define("TDOMF_KEY_STATUS","_tdomf_status");
-
-
-/////////////////
-// 0.7 Settings
-//
-define('TDOMF_FOLDER', dirname(plugin_basename(__FILE__)));
-define('TDOMF_FULLPATH', WP_PLUGIN_DIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER.DIRECTORY_SEPARATOR);
-#define('TDOMF_FULLPATH', ABSPATH.PLUGINDIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER.DIRECTORY_SEPARATOR);
-define('TDOMF_URLPATH', get_option('siteurl').'/wp-content/plugins/'.TDOMF_FOLDER.'/');
-define('TDOMF_WIDGET_PATH',TDOMF_FULLPATH.'widgets/');
-define('TDOMF_VERSION_CURRENT', "tdomf_version_current");
-define('TDOMF_LOG', "tdomf_log");
-define('TDOMF_OPTION_MODERATION', "tdomf_enable_moderation");
-define('TDOMF_OPTION_TRUST_COUNT', "tdomf_trust_count");
-define('TDOMF_OPTION_ALLOW_EVERYONE', "tdomf_allow_everyone");
-define('TDOMF_OPTION_AJAX', "tdomf_ajax");
-define('TDOMF_OPTION_PREVIEW', "tdomf_preview");
-define('TDOMF_OPTION_FROM_EMAIL', "tdomf_from_email");
-define('TDOMF_OPTION_AUTHOR_THEME_HACK', "tdomf_author_submitter");
-define('TDOMF_OPTION_FORM_ORDER', "tdomf_form_order");
-define('TDOMF_OPTION_ADD_SUBMITTER', "tdomf_add_submitter_info");
-define('TDOMF_CAPABILITY_CAN_SEE_FORM', "tdomf_can_see_form");
-define('TDOMF_STAT_SUBMITTED', "tdomf_stat_submitted");
-define('TDOMF_USER_STATUS_OK', "Normal");
-define('TDOMF_USER_STATUS_BANNED', "Banned");
-define('TDOMF_USER_STATUS_TRUSTED', "Trusted");
-define('TDOMF_KEY_NOTIFY_EMAIL', "_tdomf_notify_email");
-
-/////////////////
-// 0.8 Settings
-//
-define('TDOMF_UPLOAD_PERMS',0777);
-define('TDOMF_UPLOAD_TIMEOUT',(60 * 60)); // 1 hour
-define('TDOMF_KEY_DOWNLOAD_COUNT',"_tdomf_download_count_");
-define('TDOMF_KEY_DOWNLOAD_TYPE',"_tdomf_download_type_");
-define('TDOMF_KEY_DOWNLOAD_PATH',"_tdomf_download_path_");
-define('TDOMF_KEY_DOWNLOAD_NAME',"_tdomf_download_name_");
-define('TDOMF_KEY_DOWNLOAD_CMD_OUTPUT',"_tdomf_download_cmd_output_");
-
-/////////////////
-// 0.9 Settings
-//
-define('TDOMF_KEY_DOWNLOAD_THUMB',"_tdomf_download_thumb_");
-define('TDOMF_OPTION_DISABLE_ERROR_MESSAGES',"tdomf_disable_error_messages");
-define('TDOMF_OPTION_EXTRA_LOG_MESSAGES',"tdomf_extra_log_messages");
-define('TDOMF_OPTION_YOUR_SUBMISSIONS',"tdomf_your_submissions");
-define('TDOMF_WIDGET_URLPATH',TDOMF_URLPATH.'widgets/');
-
+<?php
+/*
+Plugin Name: TDO Mini Forms
+Plugin URI: http://thedeadone.net/download/tdo-mini-forms-wordpress-plugin/
+Description: This plugin allows you to add custom posting forms to your website that allows your readers (including non-registered) to submit posts.
+Version: 0.13.5
+Author: Mark Cunningham
+Author URI: http://thedeadone.net
+*/
+
+/*  Copyright 2006-2007  Mark Cunningham  (email : tdomf@thedeadone.net)
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+////////////////////////////////////////////////////////////////////////////////
+// Version History
+//
+// See readme.txt
+//
+// v0.13.5
+// - Previous recent versions prevented people from enabling spam. The code was
+//     written in such a way that the spam protection had to be enabled before
+//     spam protection could be enabled!
+// - Replaced the usage of $_REQUEST with $_POST in form hacker. Not sure if
+//     it'll have any impact on the form-hacker-reset problem but it should
+//     be safer
+// - Have tested and fixed extra slashes being added on WP 2.8.x builds with and
+//     without magic quotes turned on. 
+// - Refactored Custom Field, Content, Excerpt widgets and created a common
+//     textfield and textarea (as part of the fix for magic quotes). This allows
+//     me to add new features to multiple widgets at a time. 
+//
+////////////////////////////////////////////////////////////////////////////////
+
+/*
+////////////////////////////////////////////////////////////////////////////////
+Work Queue:
+
+Bugs
+====
+   - 'gmt_offset' not calcualted in %%SUBMISSIONDATE%%
+   - not working with vbbridge - http://thedeadone.net/forum/?p=2805#comment-4296
+   - image capatcha must update after failed "submit"
+   - Possible incompatibility with Google XML Sitemaps plugin - http://thedeadone.net/forum/?p=1923
+   - Bug in GeoMashup - http://thedeadone.net/forum/?p=2062#comment-4070
+   - Bug TwitterTools not working with TDOMF publish - http://thedeadone.net/forum/?p=1916#comment-3972
+   - Sanatized file upload filenames/paths - http://thedeadone.net/blog/v0127-of-tdo-mini-forms-just-released/comment-page-1/#comment-181601
+   - diacritc marks reset form hacker: http://thedeadone.net/forum/?p=1888#topic-1888
+   - Bug: Illegal characters in file names: http://thedeadone.net/forum/?p=1544#topic-1544
+   - Bug: Weird "From" email for post moderation emails: http://thedeadone.net/forum/?p=71
+   - Bug: No image preview when using attachment options: http://thedeadone.net/forum/?p=1498#comment-3485
+   - Bug: slashes: http://thedeadone.net/forum/?p=1444#comment-3331 (but it might be related to AJAX!)
+   - Bug: Widget configuration panels not showing up: http://thedeadone.net/forum/?p=1379
+   - Investigate: no sidebars in widget configuration in IE.7
+   - Investigate: tinymce conflict with AJAX form
+   - Investigate: upload-link error:
+       http://wordpress.org/support/topic/186919#post-838957
+
+TODO
+====
+   - Allow options to format the "submitted by" text and also disabling for registered users
+   - Quicktag like options for form hacker
+   - Investigate: Copy widgets to other forms
+   - Allow Error, StyleSheet and Validation Form Hacking
+   - Allow only the Form or the Preview to be "hacked" in the Form Hacker
+   - Add Error Warning for custom field widgets when non-unique keys used
+   - Investigate: Auto bring up the conf panel for widgets on the "fix" links
+
+Feature Requests
+================
+   - delete spam straight away (TDOMF_OPTION_SPAM_AUTO_DELETE_NOW already setup, just not implemented)
+   - parent category - http://thedeadone.net/forum/?p=3205#comment-4524
+   - display less information and perhaps some sort of funky JS to order columns - http://thedeadone.net/forum/?p=3526#comment-4514
+   - category names instead of ids - http://thedeadone.net/forum/?p=3171#topic-3171
+   - widget class have functions to allow message customisation
+   - "delete all spam"
+   - "recheck for spam"
+   - Most pages private... - http://thedeadone.net/forum/?p=224#comment-4221
+   - Requred option in category field
+   - Related posts! http://thedeadone.net/forum/?p=1904#comment-3937
+   - Entry in FAQ: Widget Changes not showing up
+   - Investigate: Integeration with NextGen
+   - Template: List of submitters
+   - Code: Tags as checkboxes - http://thedeadone.net/forum/?p=1377
+   - Some simple javascript to track number of chars/words typed so far in textarea: http://thedeadone.net/forum/?p=1321
+   - Study: http://wordpress.org/extend/plugins/download-monitor/ integration
+
+Other
+=====
+   - Code to add a email hook on publish - http://thedeadone.net/forum/?p=3195#comment-4519
+   - http://thedeadone.net/forum/?p=2100#comment-4278 (alternative input?)   
+
+
+*/
+
+/*
+Magic Quotes for 0.13.5:
+
+Wordpress 2.8.2
++++++++++++++++
+
+Magic Quotes: ON
+================
+Widget Screen    : OK
+Form Hacker      : OK
+
+[AJAX: On]         Title | Content | Excerpt | CF: TextArea | CF: TextField
+--------------------------------------------------------------------------          
+New-Post-Preview : OK    | OK      | OK      | OK           | OK
+New-Post-Submit  : OK    | OK      | OK      | OK           | OK
+Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
+Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
+
+[AJAX: Off]        Title | Content | Excerpt | CF: TextArea | CF: TextField
+--------------------------------------------------------------------------
+New-Post-Preview : OK    | OK      | OK      | OK           | OK
+New-Post-Submit  : OK    | OK      | OK      | OK           | OK
+Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
+Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
+
+Magic Quotes: OFF
+=================
+Widget Screen    : OK
+Form Hacker      : OK
+
+[AJAX: On]         Title | Content | Excerpt | CF: TextArea | CF: TextField
+--------------------------------------------------------------------------          
+New-Post-Preview : OK    | OK      | OK      | OK           | OK
+New-Post-Submit  : OK    | OK      | OK      | OK           | OK
+Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
+Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
+
+[AJAX: Off]        Title | Content | Excerpt | CF: TextArea | CF: TextField
+--------------------------------------------------------------------------
+New-Post-Preview : OK    | OK      | OK      | OK           | OK
+New-Post-Submit  : OK    | OK      | OK      | OK           | OK
+Edit-Post-Preview: OK    | OK      | N/A     | N/A          | N/A
+Edit-Post-Submit : OK    | OK      | N/A     | N/A          | N/A
+
+*/
+
+/*
+////////////////////////////////////////////////////////////////////////////////
+Notes:
+ - Potential nice hack: query.php @ line 1479
+   $this->posts = apply_filters('the_posts', $this->posts);
+     1. is single/page [should include category and index?]
+     2. what post?
+     3. is it tdomf, draft/unmoderation, not spam, viewer is submitter
+     4. add to array
+     This will allow users see their submitted posts, however comments should
+     be disabled as they cannot be used in preview mode
+ - What Clickable links in your posts? http://thedeadone.net/forum/?p=500#comment-1598
+*/
+
+ /*
+////////////////////////////////////////////////////////////////////////////////
+TODO for future versions
+
+Known Bugs
+- Upload Link error
+- TinyMCE integration problem with AJAX
+
+New Features
+- Option to redirect all comment notifications on submitted posts to the admin (globally or per form)
+- Allow moderators append a message to the approved/rejected notification (allows communication between submitter and moderator)
+- Widget Manager Menu
+  * Info about loaded widgets
+  * Disable loading of specific widgets
+- Style Sheet Editor
+  * Preview
+  * Select from pre-configured Styles
+  * Submit new style to include in TDOMF
+- Email verification of non-registered users
+- Manage Downloads page
+- Authors of posts should be able to see "previews" of post
+- Get input during validation of form (for capatchas)
+- Option to use "Post ready for review" instead of draft for unapproved submitted posts
+- Turn Forms into multiple steps
+- Shortcode Support
+
+New Form Options
+- Force Preview before submission
+- Hide Form on Preview
+- Forms can be used to submit links, emails, etc.
+- Select Form Style/include Custom CSS
+
+New Widgets
+- Widget to allow user to enter a date to post the submission (as in future post)
+- Widget to allow submitter to copy the submission to another email
+- Widget that inputs only title
+  * or that allows formatting of title by
+  * user-input
+  * custom field
+  * username/submitter
+  * date submitted (requires date/time format)
+  * PHP code
+- Login/Register/Who Am I Widget
+
+Existing Widget Improvements
+- Any widget with a size or length field should be customisable.
+- Textfield Class (support numeric, date, email, webpage, etc.)
+- Textarea Class
+- Copy Widget to another Form
+- Individual save
+- Upload Files
+  * Multiple Instances
+  * Thumbnail size
+  * Limit size of image by w/h
+  * Image cropping
+  * Title field for file links/attachment pages
+  * Nicer integration: background uploading using iframe
+  * Prevent submission until files uploaded
+  * Progress bar
+- Content
+  * TinyMCE Integration
+  * Allow users to define their own quicktags
+  * Mechanism to allow sumitter to select where the link/image for upload should go
+  * Default Value
+- Custom Field: Textarea
+  * TinyMCE Integration
+  * Allow users to define their own quicktags
+  * Mechanism to allow sumitter to select where the link/image for upload should go
+  * Default Value
+- Custom Field
+  * Radio Groups
+  * Multiple Checkboxes (grid-layout)
+- Custom Field: Textfield
+  * Numeric
+  * Date
+- Custom Field: Select
+  * Required support
+- Tags
+  * Select from existing tag list or tag cloud
+  * Select from only a specified set of tags
+- 1 Question Captcha
+  * Random questions for Captcha
+- Category
+  * Co-operate with "Set Category from GET variables" Widget
+- Notify Me
+  * Option to always notify submitter
+- Image Captcha
+  * Do not reload image on every preview (would be resolved by a seperate validation step)
+- Text
+  * Option to not use the form formatting (i.e. no "<fieldset>" tags before and after)
+  * Option to have the text popup (would require a HTML space for the link)
+- Set Category from GET variables
+  * Add options (or at least information) for this widget
+  * Co-operate with "Categories" Widget
+- Who Am I
+  * Integration with WP-OpenID?
+  * Allow login as part of form submit
+- Categories
+  * Categories displayed but unselectable
+
+Template Tags
+- Log
+- Moderation Queue
+- Approved Posts
+- File Info
+- Country codes on submitter's IP
+- Image Tags
+
+Misc
+- Documentation on creating your own widgets
+
+////////////////////////////////////////////////////////////////////////////////
+*/
+
+///////////////////////////////////////////////////
+// Defines and other global vars for this Plugin //
+///////////////////////////////////////////////////
+
+// Older versions of PHP may not define DIRECTORY_SEPARATOR so define it here,
+// just in case.
+if(!defined('DIRECTORY_SEPARATOR')) {
+  define('DIRECTORY_SEPARATOR','/');
+}
+
+// Build Number (must be a integer)
+define("TDOMF_BUILD", "51");
+// Version Number (can be text)
+define("TDOMF_VERSION", "0.13.4");
+
+///////////////////////////////////////
+// 0.1 to 0.5 Settings (no longer used)
+//
+define("TDOMF_ACCESS_LEVEL", "tdomf_access_level");
+define("TDOMF_NOTIFY_LEVEL", "tdomf_notify_level");
+
+///////////////////////////////////////
+// 0.6 Settings (no longer used)
+//
+define('TDOMF_NOTIFY','tdomf_notify');
+define("TDOMF_ITEMS_PER_PAGE", 30);
+define("TDOMF_POSTS_INDEX",    0);
+define("TDOMF_USERS_INDEX",    1);
+define("TDOMF_IPS_INDEX",      2);
+define("TDOMF_OPTIONS_INDEX",  3);
+
+/////////////////
+// 0.6 Settings
+//
+define("TDOMF_ACCESS_ROLES", "tdomf_access_roles");
+define("TDOMF_NOTIFY_ROLES", "tdomf_notify_roles");
+define("TDOMF_DEFAULT_CATEGORY", "tdomf_default_category");
+define("TDOMF_DEFAULT_AUTHOR", "tdomf_default_author");
+define("TDOMF_AUTO_FIX_AUTHOR", "tdomf_auto_fix_author");
+define("TDOMF_BANNED_IPS", "tdomf_banned_ips");
+//
+// These keys are used to store info about a post, on the post.
+// Keys with underscore prefix (i.e. "_") are hidden from the general user. Keys
+// without can be modified and displayed using Wordpress normal features such as
+// template tags and custom fields editor.
+//
+define("TDOMF_KEY_FLAG","_tdomf_flag");
+define("TDOMF_KEY_NAME","Author Name");
+define("TDOMF_KEY_EMAIL","Author Email");
+define("TDOMF_KEY_WEB","Author Webpage");
+define("TDOMF_KEY_IP","_tdomf_original_poster_ip");
+define("TDOMF_KEY_USER_ID","_tdomf_original_poster_id");
+define("TDOMF_KEY_USER_NAME","Original Submitter Username");
+//
+// This key is very important. It determines if a user is trusted or banned..
+//
+define("TDOMF_KEY_STATUS","_tdomf_status");
+
+
+/////////////////
+// 0.7 Settings
+//
+define('TDOMF_FOLDER', dirname(plugin_basename(__FILE__)));
+define('TDOMF_FULLPATH', WP_PLUGIN_DIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER.DIRECTORY_SEPARATOR);
+#define('TDOMF_FULLPATH', ABSPATH.PLUGINDIR.DIRECTORY_SEPARATOR.TDOMF_FOLDER.DIRECTORY_SEPARATOR);
+define('TDOMF_URLPATH', get_option('siteurl').'/wp-content/plugins/'.TDOMF_FOLDER.'/');
+define('TDOMF_WIDGET_PATH',TDOMF_FULLPATH.'widgets/');
+define('TDOMF_VERSION_CURRENT', "tdomf_version_current");
+define('TDOMF_LOG', "tdomf_log");
+define('TDOMF_OPTION_MODERATION', "tdomf_enable_moderation");
+define('TDOMF_OPTION_TRUST_COUNT', "tdomf_trust_count");
+define('TDOMF_OPTION_ALLOW_EVERYONE', "tdomf_allow_everyone");
+define('TDOMF_OPTION_AJAX', "tdomf_ajax");
+define('TDOMF_OPTION_PREVIEW', "tdomf_preview");
+define('TDOMF_OPTION_FROM_EMAIL', "tdomf_from_email");
+define('TDOMF_OPTION_AUTHOR_THEME_HACK', "tdomf_author_submitter");
+define('TDOMF_OPTION_FORM_ORDER', "tdomf_form_order");
+define('TDOMF_OPTION_ADD_SUBMITTER', "tdomf_add_submitter_info");
+define('TDOMF_CAPABILITY_CAN_SEE_FORM', "tdomf_can_see_form");
+define('TDOMF_STAT_SUBMITTED', "tdomf_stat_submitted");
+define('TDOMF_USER_STATUS_OK', "Normal");
+define('TDOMF_USER_STATUS_BANNED', "Banned");
+define('TDOMF_USER_STATUS_TRUSTED', "Trusted");
+define('TDOMF_KEY_NOTIFY_EMAIL', "_tdomf_notify_email");
+
+/////////////////
+// 0.8 Settings
+//
+define('TDOMF_UPLOAD_PERMS',0777);
+define('TDOMF_UPLOAD_TIMEOUT',(60 * 60)); // 1 hour
+define('TDOMF_KEY_DOWNLOAD_COUNT',"_tdomf_download_count_");
+define('TDOMF_KEY_DOWNLOAD_TYPE',"_tdomf_download_type_");
+define('TDOMF_KEY_DOWNLOAD_PATH',"_tdomf_download_path_");
+define('TDOMF_KEY_DOWNLOAD_NAME',"_tdomf_download_name_");
+define('TDOMF_KEY_DOWNLOAD_CMD_OUTPUT',"_tdomf_download_cmd_output_");
+
+/////////////////
+// 0.9 Settings
+//
+define('TDOMF_KEY_DOWNLOAD_THUMB',"_tdomf_download_thumb_");
+define('TDOMF_OPTION_DISABLE_ERROR_MESSAGES',"tdomf_disable_error_messages");
+define('TDOMF_OPTION_EXTRA_LOG_MESSAGES',"tdomf_extra_log_messages");
+define('TDOMF_OPTION_YOUR_SUBMISSIONS',"tdomf_your_submissions");
+define('TDOMF_WIDGET_URLPATH',TDOMF_URLPATH.'widgets/');
+
 ////////////////
 // 0.10 Settings
 //
